﻿### Установить наблюдение за каталогом, определить фильтр для наблюдаемых файлов, отслеживать изменения за подкаталогами да/нет  
    # Переменная $watcher прослушивает уведомления об изменении в файловой системе.
    $watcher = New-Object System.IO.FileSystemWatcher
    # Устанавливает наблюдение за указанным каталогом
    $watcher.Path = "C:\test"
    # Фильтр для наблюдения за файлом. В данном случае ведется наблюдение за всеми типами файлов и каталогов
    $watcher.Filter = "*.*"
    # Следить за изменениями в подкаталогах. Чтобы отключить измените $true на $false
    $watcher.IncludeSubdirectories = $true
    # вызывает действие после события (изменения)
    $watcher.EnableRaisingEvents = $true  

### Определит функцию действие после события
    $action = { 
                # Полный пук к файлу или каталогу в котором было выполнено изменение
                $path = $Event.SourceEventArgs.FullPath
                # Какое изменение было выполнено
                $changeType = $Event.SourceEventArgs.ChangeType
                # Создаем строку для записи в лог файл. Строка содержит время, тип изменения и название файла или каталога в котором было выполнено изменение
                $logline = "$(Get-Date), $changeType, $path"
                # Записываем переменную $logline в лог файл. Команда Add-Content добавляет новою строку (не переписывает )в лог файл.
                Add-content "C:\test\log.txt" -value $logline
              } 
                 
### Выбираем какие типы изменений будут логироватся
    # Логировать создание файла или каталога
    Register-ObjectEvent $watcher "Created" -Action $action
    ### Register-ObjectEvent $watcher "Changed" -Action $action
    # Логировать удаление файла или каталога
    Register-ObjectEvent $watcher "Deleted" -Action $action
    # Логировать переименование файла или каталога
    Register-ObjectEvent $watcher "Renamed" -Action $action
    # Скрипт уходит в ждущий режим на 5 секунд. По истечению заданного интервала скрипт проверяет если изменения. 
    # Если изменение были тогда эти изменения записываются в лог файл. Если изменений не было скрипт уходит в ждущий режим на 5 секунд.
    while ($true) {sleep 5}